from typing import List


class Solution:
    def smallestCommonElement(self, mat: List[List[int]]) -> int:
        d = {}
        l = len(mat)
        for nums in mat:
            for num in nums:
                d[num] = d.get(num,0)+1

        r = [key for key, val in d.items() if val == l]
        if len(r):
            return r[0]
        else:
            return -1


if __name__ == "__main__":
    soln = Solution()
    # m x n
    mat = [[1, 2, 3, 4, 5],
           [2, 4, 5, 8, 10],
           [3, 5, 7, 9, 11],
           [1, 3, 5, 7, 9]]

    mat = [[1, 2, 3], [2, 3, 4], [2, 3, 5]]
    mat = [[25,116,165,306,343,380,385,386,407,420,435,567,852,908,967,971,1175,1279,1479,1524,1541,1642,1689,1780,1904,2001,2139,2188,2230,2328,2415,2527,2558,2571,2607,2716,2918,2926,2933,3079,3157,3162,3285,3896,4013,4197,4407,4509,4817,4851,4897,4970,5175,5220,5312,5401,5477,5601,5838,5878,5902,6112,6140,6388,6508,6594,6670,6764,7144,7230,7267,7405,7508,7548,7564,7574,7738,7739,7763,7859,7882,7908,7959,8228,8321,8430,8431,8497,8524,8625,8672,8971,9122,9310,9387,9434,9505,9542,9582,9653],[36,70,153,164,304,570,583,587,592,661,1035,1342,1362,1451,1596,1623,1822,2179,2192,2482,2532,2674,2715,2781,2802,2850,2877,2908,2916,2928,2941,2966,2981,3040,3051,3101,3115,3150,3177,3311,3338,3340,3391,3507,3916,3937,4009,4120,4260,4265,4364,4635,4826,4907,4938,4973,5003,5024,5034,5055,5066,5237,5332,5588,5627,5963,6035,6053,6155,6275,6376,6428,6472,6479,6492,6848,6890,6916,6975,7485,7679,7803,7825,7966,8198,8248,8332,8421,8583,8866,9074,9092,9124,9221,9251,9337,9443,9543,9863,9936],[28,123,159,185,249,343,454,542,545,797,1551,1646,1825,2039,2118,2129,2185,2439,2453,2465,2686,2711,2715,2777,2799,2810,2821,2973,3221,3270,3361,3367,3451,3468,3527,3548,3751,3844,3870,3897,4150,4648,4685,4853,4976,5085,5169,5520,5585,5703,5800,5860,5917,5923,5971,5988,6455,6529,6636,6681,6684,6751,6775,6808,6823,6925,6956,7008,7123,7222,7227,7333,7514,7521,7664,7938,7959,8003,8160,8166,8334,8491,8525,8535,8560,8780,8919,9153,9309,9462,9533,9543,9740,9744,9759,9843,9854,9919,9960,9969],[128,385,666,671,812,824,901,957,998,1153,1324,1401,1457,1472,1512,1549,1590,1596,1698,2050,2161,2263,2320,2336,2451,2793,2938,2956,3012,3050,3059,3384,3559,3639,3757,3876,3934,4128,4232,4336,4392,4528,4623,4645,4653,4853,4868,4919,4924,5167,5202,5203,5269,5334,5394,5435,5436,5521,5762,5810,5869,5950,6035,6068,6410,6533,6659,6663,6741,6824,6829,7033,7098,7135,7247,7265,7557,7562,7596,8076,8089,8334,8589,8600,8767,8990,9024,9065,9073,9162,9181,9319,9428,9609,9800,9855,9857,9926,9929,9953],[102,161,394,400,455,574,643,760,885,1121,1161,1343,1559,1633,1724,1790,1806,1895,2120,2345,2418,2653,2930,3105,3176,3203,3216,3294,3306,3409,3416,3494,3502,3506,3553,3624,3639,3655,3727,3755,3981,4191,4275,4402,4569,4638,4669,4899,4972,5183,5231,5522,5524,5943,6015,6025,6088,6163,6187,6267,6278,6409,6420,6450,6520,6755,6770,6783,6865,6894,7093,7165,7382,7485,7575,7732,7779,7816,7889,8140,8223,8285,8367,8482,8535,8548,8775,9005,9020,9051,9163,9234,9254,9352,9514,9682,9698,9731,9922,9973],[48,127,195,382,439,486,527,791,817,830,852,1028,1265,1356,1411,1434,1512,1577,1734,1888,1911,1986,2015,2022,2075,2126,2180,2257,2495,2553,2617,2808,2832,2891,3056,3333,3387,3422,3710,3943,4064,4174,4182,4281,4712,4953,4966,5026,5207,5281,5453,5557,5600,5666,5692,5706,5799,5937,5949,6009,6513,6525,6651,6668,6686,6705,6717,6732,6887,6915,6927,6995,6997,7104,7165,7222,7335,7342,7381,7564,7986,8095,8365,8498,8645,8819,8854,9059,9071,9219,9482,9485,9534,9562,9678,9718,9812,9844,9871,9997],[13,155,297,592,602,653,756,832,851,923,944,1022,1040,1185,1379,1428,1566,1647,1681,1966,2046,2122,2144,2229,2345,2361,2476,2491,2625,2713,2738,2900,2949,3056,3294,3357,3417,3547,3585,3625,4014,4028,4217,4495,4554,4571,4610,4744,4818,4855,4989,5044,5085,5484,5683,5688,5804,5939,5985,6067,6115,6255,6467,6595,6641,6822,6860,7040,7101,7178,7420,7458,7579,7592,7640,7722,7982,8005,8104,8273,8283,8336,8430,8463,8519,8605,8693,8775,8815,8847,8850,8974,9024,9115,9381,9417,9489,9577,9660,9875],[296,450,579,759,996,1092,1122,1346,1357,1608,1674,1688,1832,1905,1918,2122,2257,2285,2295,2350,2433,2458,2521,2611,2640,2674,2805,2845,2892,2971,3137,3222,3521,3706,3893,3946,3972,3973,4244,4271,4287,4292,4385,4495,4538,4831,4935,4982,5016,5063,5142,5199,5278,5307,5338,5375,5635,5752,5766,5788,5791,5839,5864,5993,6010,6023,6079,6113,6160,6609,6721,6867,7018,7055,7193,7243,7269,7282,7414,7444,7469,7500,7553,8444,8505,8703,8752,8757,8936,9036,9043,9045,9072,9189,9570,9647,9659,9687,9819,9947],[13,170,413,528,735,869,890,906,970,1205,1306,1324,1338,1615,1713,2044,2064,2179,2180,2189,2355,2448,2650,2680,2923,2950,2958,3068,3088,3246,3316,3375,3412,3501,3519,3865,3950,4064,4253,4298,4372,4524,4612,4680,4767,4782,4790,4894,4937,4977,5142,5160,5195,5196,5257,5302,5370,5444,5538,5595,5686,5743,5843,5916,5931,6010,6011,6174,6323,6357,6559,6582,6635,6678,6933,7089,7303,7325,7395,7492,7649,7959,8001,8131,8142,8197,8234,8446,8813,8839,8872,8878,8880,9002,9096,9115,9628,9677,9845,9887],[139,262,452,512,561,903,931,946,1169,1321,1354,1369,1404,1425,1429,1446,1641,1851,1996,2100,2182,2327,2417,2438,2573,2574,2653,3082,3089,3406,3425,3433,3557,3961,4007,4097,4160,4165,4380,4414,4709,4872,4888,4921,4964,4972,5068,5081,5108,5149,5638,5757,5791,5813,6022,6194,6230,6259,6425,6442,6463,6491,6526,6683,6769,6804,6825,6977,6993,7076,7209,7379,7443,7480,7580,7604,7776,7779,7793,7800,7860,7923,7927,8011,8177,8223,8255,8258,8293,8530,8626,8675,9030,9257,9347,9383,9417,9480,9710,9763],[113,128,273,329,378,407,609,646,1036,1068,1259,1360,1402,1442,1481,1589,1702,1801,1860,2021,2043,2127,2329,2435,2502,2544,2623,2629,2630,2685,2747,2853,2866,2952,3259,3441,3461,3733,3740,3859,3901,4237,4317,4402,4409,4434,4540,4558,4604,4633,4651,4671,4751,4754,4834,4855,4909,5233,5261,5307,5602,5691,5916,5999,6259,6331,6355,6374,6395,6647,6679,6731,6793,6799,6863,6935,7006,7288,7350,7361,7375,7428,7691,7698,7715,7744,8088,8318,8499,8759,8763,8857,8865,8894,8955,9092,9141,9162,9570,9681],[123,308,350,456,530,745,848,936,1013,1211,1220,1224,1269,1367,1395,1401,1407,1439,1454,1475,1646,1761,1783,1811,1927,1972,2098,2132,2185,2233,2324,2330,2347,2614,2646,2962,3028,3055,3160,3291,3360,3406,3459,3618,3882,4116,4134,4315,4321,4395,4426,4898,5101,5105,5179,5388,5456,5494,5613,5636,5667,5837,5907,6040,6265,6390,6400,6448,6530,6555,6638,6715,6791,6803,6866,6921,6941,7114,7345,7358,7368,7420,7604,7699,7749,7804,8105,8224,8336,8372,8661,8913,9187,9229,9255,9406,9508,9568,9746,9835],[41,167,182,210,307,395,435,549,598,680,692,866,932,954,1053,1123,1207,1321,1503,1554,1607,1709,1804,2048,2135,2172,2454,2480,2510,2524,2565,2576,2722,2949,2975,3008,3184,3393,3397,3430,3450,3471,3541,3553,3639,3676,3944,4031,4254,4330,4399,4405,4595,4676,4957,5159,5216,5347,5544,5853,5912,6082,6112,6123,6158,6212,6256,6301,6381,6401,6492,6538,6603,6786,7105,7161,7194,7263,7459,7689,7737,7953,7954,7969,7999,8108,8169,8258,8294,8456,8479,8708,8836,8916,8929,9028,9529,9645,9719,9805],[231,307,316,340,413,454,458,695,816,975,1343,1566,1659,1965,2078,2153,2297,2301,2317,2433,2504,2528,2553,2605,2659,2832,2873,2916,3225,3262,3392,3401,3506,3564,3584,3773,3816,3990,4026,4174,4236,4257,4459,4636,4692,4694,4888,5289,5486,5494,5511,5522,5583,5806,5906,6040,6110,6228,6252,6270,6415,6504,6529,6569,6591,6860,6864,6917,7002,7008,7213,7223,7462,7483,7512,7605,7895,7920,8147,8362,8393,8423,8485,8644,8780,8838,9034,9195,9305,9309,9391,9399,9476,9631,9673,9684,9762,9786,9850,9862],[33,132,136,242,336,422,563,571,744,909,1168,1249,1525,1721,1781,1915,1977,2008,2371,2427,2470,2551,2602,2731,2800,2932,2992,3006,3024,3154,3448,3596,3671,3677,3880,3928,3950,4012,4145,4205,4626,4691,4730,5026,5038,5089,5190,5196,5233,5770,5826,5864,5879,5889,5892,6137,6272,6341,6407,6625,6635,6652,6710,6804,6970,7024,7036,7082,7202,7221,7440,7623,7673,7757,7814,7908,7927,8056,8076,8082,8160,8161,8203,8306,8435,8547,8601,8700,8837,8864,8867,8904,9107,9154,9180,9281,9298,9302,9410,9572],[199,259,260,283,353,384,566,707,711,849,859,914,1103,1273,1436,1473,1483,1539,1546,1805,1866,2216,2237,2265,2305,2334,2398,2616,2707,2777,2797,2885,3020,3055,3085,3267,3496,3517,3664,3708,3801,4244,4289,4582,4750,4757,4792,4835,4883,5085,5093,5095,5130,5183,5454,5472,5517,5658,5785,5962,6064,6102,6105,6158,6159,6627,6743,6835,6850,7318,7366,7445,7707,7717,7785,7797,7809,7823,7913,8070,8234,8278,8333,8369,8572,8615,8624,8644,8658,8841,8917,8959,8971,8986,9083,9290,9410,9616,9846,9922],[25,119,152,198,270,312,339,341,433,711,821,843,846,920,941,947,1043,1112,1127,1283,1410,1672,1686,1871,1903,1947,1976,2018,2081,2101,2157,2464,2483,2543,2613,2671,2819,2872,3191,3278,3362,3390,3415,3423,3506,3530,3567,3733,3922,4075,4076,4111,4151,4180,4186,4294,4355,4400,4424,4561,4604,4621,4653,4686,4872,4920,4953,4958,5190,5315,5416,6003,6212,6276,6623,6676,6686,7072,7204,7333,7504,7552,7636,7724,7747,8034,8069,8092,8304,8381,8420,8443,8719,8895,9055,9257,9469,9761,9870,9939],[46,321,335,400,454,647,651,682,860,920,963,1018,1045,1127,1255,1311,1413,1543,1738,2128,2143,2154,2174,2202,2388,2401,2463,2891,2902,3032,3125,3152,3402,3412,3437,3486,3610,3637,3804,3921,3933,3937,3948,4059,4214,4250,4271,4327,4489,4641,4653,4878,5244,5264,5421,5475,5506,5513,5537,5608,5740,5844,6128,6349,6381,6386,6518,6694,6723,6923,6954,7036,7112,7115,7140,7166,7253,7294,7330,7411,7448,7837,7995,8036,8114,8165,8314,8417,8473,8603,8708,8911,9054,9248,9267,9436,9461,9477,9840,9924],[34,71,181,182,225,303,329,512,546,557,867,1194,1260,1534,1818,1831,1971,2019,2028,2081,2150,2410,2455,2563,2569,2859,3180,3305,3385,3457,3501,3829,3840,3844,3873,3996,4009,4059,4062,4087,4229,4462,4482,4512,4572,4713,4747,4795,4839,4910,5020,5027,5063,5155,5220,5269,5372,5474,5549,5664,5736,5777,5804,5831,6050,6319,6330,6610,6635,6777,6805,7210,7243,7320,7413,7574,7726,7845,8024,8183,8405,8593,8613,8764,8766,8818,8872,8901,8936,8968,9261,9313,9563,9600,9632,9737,9758,9911,9964,9980],[109,272,299,378,395,399,564,621,883,885,887,1041,1245,1305,1552,1712,1890,1959,2092,2135,2217,2262,2436,2542,2564,2645,2666,2788,2957,2974,3040,3129,3138,3260,3263,3297,3304,3405,3433,3982,4043,4203,4210,4259,4277,4286,4330,4390,4432,4495,4528,4600,4608,4769,4943,4958,4971,5081,5179,5237,5358,5503,5906,6008,6198,6316,6395,6471,6592,6602,6706,6733,6865,6936,6960,7018,7055,7341,7367,7641,7743,7771,7785,7803,7886,8033,8106,8154,8474,8574,8635,8680,8811,8936,9577,9685,9756,9840,9872,9873],[61,249,513,601,861,871,874,968,1152,1282,1322,1334,1567,1837,1959,1962,1971,1982,1987,2090,2245,2268,2373,2440,2449,2450,2571,2678,2953,3056,3073,3081,3163,3337,3650,3670,3729,3865,3987,4009,4130,4294,4328,4374,4674,4823,5021,5086,5109,5252,5309,5315,5367,5441,5552,5593,5633,5757,5820,5946,6031,6202,6237,6262,6858,6874,6910,6998,7084,7241,7324,7382,7471,7655,7712,7763,7828,7903,8112,8149,8325,8447,8461,8589,8624,8744,8761,8783,8789,8853,8907,9103,9209,9215,9483,9509,9590,9822,9959,9980],[31,121,327,694,826,939,955,1072,1248,1507,1858,1878,2012,2038,2189,2312,2398,2491,2637,2888,3084,3302,3325,3351,3386,3624,3687,3721,3823,3900,3904,3981,4062,4208,4229,4317,4375,4482,4590,4619,4670,4689,4790,4917,5012,5292,5298,5354,5365,5513,5541,5544,5549,5858,5957,6100,6118,6323,6368,6442,6478,6564,6565,6671,6684,6714,6738,6771,6773,6789,6869,6997,7026,7200,7306,7336,7415,7429,7540,7660,7687,7730,7798,7877,7891,8067,8265,8384,8479,8659,8791,9150,9171,9190,9208,9528,9640,9643,9716,9787],[82,107,181,502,543,544,590,745,784,1079,1393,1449,1467,1498,1519,1618,1658,1839,1849,2032,2118,2128,2140,2302,2378,2403,2773,2802,2907,2946,2972,3117,3246,3331,3465,3484,3533,3582,3619,3674,3688,3824,3844,3849,3869,3969,4388,4412,4463,4582,4779,4793,4882,5000,5134,5199,5251,5270,5317,5520,5560,5610,5838,6061,6207,6700,6724,6762,6773,6908,7037,7049,7147,7239,7275,7658,7908,7920,8017,8175,8190,8336,8364,8370,8484,8870,8988,9004,9240,9245,9307,9532,9572,9595,9626,9645,9655,9828,9878,9990],[157,219,339,359,423,533,558,594,664,690,732,834,926,1135,1278,1288,1484,1627,1742,1754,1804,2012,2135,2143,2185,2204,2494,2665,2958,2990,3016,3122,3129,3278,3280,3443,3463,3574,3982,3998,4003,4008,4032,4072,4344,4387,4450,4648,4822,4916,4992,5113,5198,5248,5251,5262,5402,5428,5442,5643,5820,5974,6144,6186,6195,6300,6359,6530,6575,6675,6869,6973,7070,7197,7732,7752,7867,7940,7986,8029,8050,8183,8224,8677,8692,8739,8855,9018,9155,9446,9555,9640,9679,9763,9817,9838,9850,9889,9914,9938],[139,174,310,384,620,680,797,867,897,945,973,985,1052,1102,1108,1111,1130,1191,1389,1417,1694,1868,2021,2555,2571,2572,2620,2648,2651,2696,2749,2771,2841,2880,2896,2972,3108,3131,3238,3305,3450,3636,3688,3712,3807,3982,4019,4139,4249,4455,4494,4542,4656,4708,4855,4921,4924,4960,5021,5065,5114,5219,5388,5485,5618,5764,5895,5943,5961,6254,6415,6519,6725,6787,6941,6992,7163,7203,7544,7571,7810,7894,7917,7948,7966,7976,8188,8200,8234,8280,8402,8654,8900,9107,9258,9395,9517,9673,9733,9794],[24,49,113,322,328,470,573,618,667,776,814,826,870,924,1143,1155,1321,1383,1655,1823,1870,2002,2081,2410,2415,2552,2647,2674,2689,2772,2836,2854,2985,3151,3190,3413,3493,3981,4033,4138,4154,4290,4399,4417,4764,4830,4881,4930,4956,4967,5137,5375,5539,5625,5631,5654,5743,5843,5863,5937,5959,6036,6040,6176,6241,6243,6331,6400,6529,6791,6811,6943,6995,7028,7116,7120,7181,7195,7256,7315,7666,7892,7909,8086,8247,8371,8522,8589,8619,8778,8868,8968,9012,9170,9284,9531,9616,9623,9779,9889],[13,145,157,174,472,547,674,682,686,698,858,970,1023,1177,1183,1264,1330,1419,1583,1603,1692,1697,1698,1831,1861,1939,2039,2145,2380,2636,2650,3034,3039,3088,3207,3208,3353,3380,3469,3727,3908,3909,3973,4015,4063,4161,4184,4400,4545,4617,4968,5193,5214,5399,5519,5564,5586,5588,5671,5675,5944,6094,6379,6439,6450,6491,6541,6602,6693,6696,6737,6773,6885,6963,7062,7262,7273,7311,7489,7920,8163,8366,8417,8500,8803,8950,8961,9002,9051,9060,9074,9230,9337,9441,9458,9564,9763,9765,9831,9863],[133,181,209,221,282,499,795,830,1139,1189,1197,1201,1225,1273,1326,1378,1404,1543,1649,1777,1977,2021,2156,2211,2247,2640,2698,2727,2756,2915,3057,3412,3422,3461,3738,3965,3995,4011,4028,4087,4176,4347,4358,4375,4434,4559,4583,4688,4873,4890,4941,4967,5273,5720,5727,5935,6036,6073,6123,6241,6457,6770,7009,7100,7106,7205,7348,7374,7430,7511,7518,7556,7576,7582,7656,7681,7951,8017,8089,8167,8186,8190,8305,8319,8621,8769,8785,8919,9002,9156,9352,9415,9463,9478,9626,9774,9823,9844,9859,9929],[212,253,264,678,845,907,1065,1286,1364,1448,1623,1994,2088,2105,2120,2395,2522,2590,2660,2827,2873,2880,2903,2948,3036,3059,3136,3143,3228,3342,3499,3546,3599,3625,3761,3764,4393,4610,4613,4708,4786,4826,4889,4953,4966,5140,5556,5658,5664,5697,5806,5904,5930,6069,6231,6316,6366,6396,6406,6537,6568,6588,6711,6852,6948,7259,7301,7408,7418,7473,7570,7573,7924,8173,8294,8317,8357,8498,8499,8540,8631,8691,8733,8882,8886,8887,8901,8923,8960,9110,9124,9169,9326,9508,9537,9547,9651,9661,9736,9955],[4,363,453,473,542,721,727,1044,1286,1429,1502,1623,1729,1770,2075,2154,2217,2272,2285,2307,2316,2324,2527,2550,2697,2841,2851,2993,3054,3159,3223,3255,3303,3386,3443,3539,3543,3620,3625,3626,3813,3846,3898,4284,4301,4430,4483,4535,4621,4644,4789,4864,4888,4889,5060,5107,5267,5626,5824,5866,5918,6106,6142,6276,6358,6435,6533,6694,6842,6883,7138,7139,7167,7267,7375,7510,7702,7710,7890,7908,8055,8302,8401,8444,8512,8538,8540,8544,8610,9003,9068,9102,9332,9490,9507,9635,9715,9766,9842,9939],[13,32,146,443,572,631,651,683,896,899,1059,1179,1238,1359,1525,1809,1905,1982,2183,2193,2233,2330,2556,2811,2875,2940,3140,3173,3248,3323,3464,3515,3545,3567,3713,3808,3827,3960,4084,4093,4122,4144,4156,4279,4350,4375,4385,4890,4988,5030,5045,5087,5138,5227,5276,5392,5459,5469,5545,5550,5655,5661,5925,6010,6030,6097,6160,6383,6412,6582,6660,6675,6718,6898,7476,7528,7573,7872,7924,8234,8425,8462,8561,8638,8654,8799,8929,8982,9198,9226,9245,9394,9442,9478,9549,9575,9695,9768,9839,9925],[64,427,790,847,936,1074,1082,1089,1154,1181,1242,1282,1602,1712,1713,2025,2067,2110,2264,2266,2332,2375,2410,2495,2540,2576,2639,2674,2678,2679,2692,2801,2808,3052,3066,3312,3532,3633,3682,3694,3747,3948,3979,4033,4040,4086,4204,4644,4715,4746,4869,4948,4991,5172,5344,5584,5624,6017,6034,6283,6290,6323,6331,6335,6409,6555,6889,6991,7122,7126,7254,7556,7796,7804,7810,7819,7820,8045,8076,8167,8242,8264,8846,8895,8965,9069,9091,9115,9151,9225,9346,9359,9375,9421,9422,9486,9513,9664,9854,9948],[85,232,408,418,431,537,543,574,608,666,703,860,897,939,993,1157,1206,1212,1215,1248,1417,1477,1498,1739,1886,1910,2090,2239,2447,2482,2502,2537,2608,2849,2869,3008,3072,3230,3692,3705,3725,3880,4075,4257,4262,4300,4370,4546,4614,4836,4967,5053,5063,5080,5180,5348,5397,5543,5695,5746,5818,5873,5922,6032,6148,6226,6295,6554,6647,6762,6826,6986,7046,7199,7361,7663,7700,7738,7764,7973,7974,8023,8043,8064,8118,8193,8274,8286,8488,8769,8840,8863,8872,8884,9155,9314,9372,9529,9569,9820],[161,212,311,328,410,643,759,768,775,777,930,960,966,990,1064,1075,1095,1104,1153,1166,1436,1466,1471,1489,1540,1597,1910,1956,2035,2065,2215,2335,2404,2418,2445,2489,2512,2661,2874,2883,3257,3349,3508,3768,3867,3911,3935,4001,4022,4374,4563,4850,4899,4913,5132,5244,5260,5277,5522,5551,5556,5575,5823,5856,5916,6041,6155,6379,6468,6584,6756,6849,6936,7077,7085,7206,7299,7453,7739,7846,7937,7946,8071,8146,8260,8280,8321,8518,8628,8777,8942,9103,9235,9315,9361,9399,9470,9547,9585,9612],[59,65,67,510,720,857,933,1025,1080,1109,1186,1252,1350,1411,1833,1913,1993,2123,2145,2253,2405,2423,2508,2530,2667,2721,2953,2999,3189,3319,3408,3491,3574,3616,3617,3703,3903,4102,4146,4165,4186,4199,4215,4248,4424,4511,4605,4623,4649,4793,4832,4911,4994,5020,5022,5124,5308,5495,5569,5772,5789,5809,6075,6096,6338,6360,6410,6417,6427,6451,6750,6879,6955,7055,7284,7308,7554,7725,7812,7835,7934,8221,8319,8323,8463,8569,8958,8993,9018,9038,9261,9300,9429,9487,9488,9579,9680,9685,9689,9963],[8,234,501,573,614,635,735,957,1142,1288,1491,1843,1893,2232,2277,2281,2465,2569,2626,2662,2669,2708,2748,2760,2858,2859,2902,2932,2975,3013,3121,3314,3379,3392,3486,3494,3540,3614,3645,3786,3969,4124,4205,4501,4682,4694,4904,4999,5107,5154,5182,5192,5474,5487,5568,5736,5816,5898,5975,6093,6274,6393,6495,6613,6880,6933,6940,7080,7090,7156,7201,7209,7221,7242,7353,7662,7753,7871,7979,8131,8151,8181,8274,8299,8417,8444,8683,8728,8793,8795,8841,8907,9103,9248,9409,9527,9576,9698,9865,9933],[19,171,220,324,386,630,908,977,1028,1081,1440,1463,1641,1742,1795,1854,1902,2000,2023,2117,2429,2474,2556,2569,2761,2796,2826,2915,3028,3205,3247,3303,3443,3490,3594,3596,3628,3629,3718,3731,3738,3806,3914,4038,4185,4460,4678,4839,4875,4983,5192,5315,5376,5552,5670,5880,5919,6031,6233,6280,6436,6595,6649,6688,6715,6729,6797,6875,6992,7048,7054,7108,7336,7396,7435,7512,7533,7735,7885,7919,7966,8150,8164,8463,8786,8798,8874,8926,9326,9351,9372,9434,9470,9496,9498,9541,9652,9772,9876,9925],[44,432,486,534,551,561,612,774,970,1290,1377,1522,1689,1747,1768,1882,2372,2580,2604,2646,2675,2772,2795,2814,3309,3368,3540,3638,4042,4098,4176,4195,4202,4220,4283,4423,4593,4715,4746,4792,4872,5103,5124,5235,5496,5611,5744,5950,6082,6116,6125,6144,6149,6238,6261,6352,6667,6696,6856,6871,7062,7071,7183,7202,7206,7221,7356,7370,7466,7797,7931,7945,7983,8064,8161,8190,8191,8240,8247,8302,8585,8764,8927,9048,9162,9176,9183,9259,9335,9427,9438,9440,9580,9601,9633,9786,9788,9843,9899,9945],[71,140,286,661,747,947,1060,1099,1242,1251,1259,1313,1552,1592,1594,1881,2132,2178,2226,2261,2286,2739,2871,3012,3187,3236,3302,3350,3369,3390,3465,3587,3665,3698,3756,3782,3812,3833,3836,3891,3937,3952,3976,4041,4059,4638,4683,4707,4730,4998,5092,5126,5183,5326,5327,5348,5353,5358,5371,5391,5601,5670,5752,5786,5795,5876,5986,6290,6374,6501,6673,6700,6722,6888,7190,7318,7397,7415,7769,7775,7814,7815,7869,8200,8292,8294,8380,8592,8912,9037,9053,9170,9174,9231,9368,9668,9780,9815,9865,9933],[271,296,337,409,514,520,802,804,820,899,1121,1269,1413,1588,1647,1710,1769,1785,1800,1856,1875,2016,2078,2213,2290,2296,2354,2441,2467,2475,2603,2633,2669,2821,2882,2951,3182,3283,3307,3350,3423,3469,3646,3907,3971,4125,4267,4387,4459,4505,4580,4597,4692,4733,4843,4852,4876,5146,5295,5376,5629,5673,5814,5854,5901,5913,5989,6175,6207,6293,6351,6591,6620,6962,7008,7028,7080,7112,7504,7745,7751,7758,7772,7787,7915,7966,8031,8134,8152,8555,8988,9021,9133,9346,9481,9536,9562,9582,9801,9834],[68,213,411,464,542,580,684,770,972,1023,1054,1179,1274,1495,1616,1767,2091,2152,2257,2283,2352,2672,2888,3306,3499,3505,3520,3535,3595,3629,3658,3963,3998,4145,4345,4403,4422,4484,4524,4581,4600,4740,4817,4836,5013,5107,5378,5412,5489,5589,5596,5611,5619,5703,5750,5914,6096,6192,6245,6310,6326,6353,6453,6509,6546,6591,6921,6960,7074,7132,7322,7362,7522,7678,7734,7818,7824,7850,7955,7991,8071,8199,8204,8366,8491,8557,8744,8796,8889,8906,9062,9208,9367,9439,9550,9628,9707,9789,9967,9987],[79,219,303,310,574,584,596,715,872,876,1183,1248,1360,1396,1422,1525,1532,1542,1622,1923,1977,2031,2048,2342,2384,2503,2551,2626,2795,2800,2868,3008,3110,3250,3270,3518,3545,3598,3635,3636,3670,3686,4151,4456,4754,4860,4911,5025,5048,5054,5100,5117,5152,5341,5478,5519,5555,5573,5633,5694,5891,6085,6543,6606,6612,6699,6713,6716,6794,6805,7071,7315,7318,7442,7654,7940,8082,8086,8137,8266,8299,8490,8501,8614,8688,8690,8713,9132,9215,9308,9338,9375,9396,9511,9533,9640,9659,9742,9790,9796],[133,159,220,287,452,478,606,608,637,663,946,1091,1094,1137,1393,1400,1501,1697,1717,1806,1904,2023,2028,2116,2152,2307,2675,2869,2889,2902,2973,3232,3273,3397,3522,3659,3725,3806,3975,4075,4107,4111,4144,4190,4256,4275,4276,4354,4459,4581,4717,4789,4904,4929,4974,5234,5281,5307,5420,5453,5507,5549,5692,5855,5893,5899,5954,6065,6107,6492,6872,6903,6906,7083,7101,7270,7273,7374,7433,7794,7852,7874,7888,8117,8209,8350,8568,8594,8626,8672,8699,9110,9273,9291,9376,9585,9612,9621,9734,9851],[6,374,458,517,528,676,700,712,945,1099,1336,1362,1400,1548,1743,1797,1951,2047,2173,2247,2320,2334,2348,2365,2568,2696,2719,2766,2901,2979,3302,3457,3558,3857,3901,3926,3961,4056,4577,4588,4657,4881,5089,5131,5156,5362,5367,5371,5531,5616,5652,6066,6238,6291,6311,6326,6390,6421,6513,6537,6621,6638,6676,6748,6829,6992,7046,7072,7229,7253,7446,7455,7642,7713,7729,7762,8026,8035,8149,8307,8597,8702,8789,8798,8814,8879,9015,9170,9191,9214,9240,9281,9317,9323,9495,9566,9675,9815,9884,9919],[33,147,183,245,358,376,379,472,556,602,999,1012,1037,1236,1323,1388,1636,1649,1659,1676,1867,1879,1910,1925,1954,1968,2025,2075,2114,2205,2226,2293,2416,2860,3037,3065,3070,3107,3161,3294,3335,3363,3514,3553,3571,3645,3864,3881,3934,4010,4013,4055,4141,4260,4365,4578,4612,5062,5078,5211,5317,5433,5530,5711,5718,5726,5739,5744,5810,5982,6021,6055,6057,6066,6136,6199,6305,6393,6431,6489,6639,6725,6795,6810,7172,7223,7306,7405,7858,7878,8081,8137,8608,8767,8800,9153,9325,9633,9645,9863],[56,171,188,291,457,503,607,783,926,1086,1248,1257,1327,1394,1417,1462,1582,1595,1704,1706,1708,1711,1725,1965,2052,2085,2125,2166,2167,2370,2448,2473,2943,2953,3196,3387,3597,3654,3790,3821,3904,3939,3980,4190,4241,4295,4303,4334,4347,4372,4425,4459,4639,4680,5000,5173,5509,5640,5668,5815,5874,6049,6054,6090,6145,6293,6613,6673,6721,6783,6840,6844,6970,6996,7098,7114,7168,7260,7270,7524,7624,7817,8024,8071,8181,8328,8333,8479,8770,8859,8943,8948,9110,9218,9351,9405,9466,9635,9744,9837],[102,176,333,480,798,861,947,1119,1442,1477,1550,1558,1621,1725,1852,2005,2025,2208,2264,2468,2516,2551,2874,2976,2991,3188,3201,3219,3336,3408,3415,3437,3484,3681,3931,3976,3987,4079,4094,4153,4192,4244,4269,4307,4325,4502,4589,4606,4628,4649,4835,4838,4956,5010,5217,5256,5312,5994,6093,6095,6197,6365,6533,6581,6640,6719,6740,6753,6758,6916,7122,7176,7362,7394,7424,7454,7517,7574,7608,7642,7675,7687,7804,7838,7864,8028,8132,8252,8306,8397,8527,8694,8871,8908,9329,9351,9543,9549,9724,9956],[98,337,541,595,638,802,903,963,970,1106,1178,1358,1412,1450,1604,1629,1634,1651,1834,1837,2044,2140,2157,2169,2529,3087,3381,3444,3475,3777,3786,3803,3842,4206,4251,4265,4319,4439,4492,4909,4930,4968,4999,5193,5296,5347,5349,5389,5581,5623,5699,5894,5944,6261,6265,6357,6532,6776,6798,6919,7041,7055,7075,7098,7157,7171,7313,7347,7409,7558,7565,7571,7687,7703,7718,7852,7872,8054,8139,8262,8269,8279,8319,8483,8484,8523,8531,8576,8596,8652,8914,9002,9270,9389,9440,9491,9742,9886,9932,9948],[55,63,265,544,660,672,770,815,855,902,1099,1226,1414,1680,1745,1808,1928,1970,2012,2053,2070,2145,2316,2344,2555,2659,2664,2692,2807,2822,2829,2848,2945,3195,3330,3616,3643,3644,3753,3785,4067,4103,4411,4443,4502,4503,4669,4832,4865,4923,5192,5223,5268,5353,5387,5429,5513,5541,5545,5830,5941,6109,6123,6237,6492,6532,6562,6821,6946,7079,7080,7187,7208,7250,7287,7484,7528,7666,7733,7832,8010,8256,8376,8667,8729,8924,8934,8985,9043,9110,9143,9278,9347,9530,9674,9687,9720,9775,9818,9835],[65,155,171,218,395,426,535,539,635,928,1054,1148,1162,1194,1244,1422,1563,1613,1653,1811,1835,1949,1982,2018,2044,2106,2233,2313,2422,2833,2972,3057,3069,3165,3191,3244,3360,3508,3538,3599,3644,3755,3896,3930,4001,4052,4114,4138,4156,4178,4261,4353,4419,4464,4479,4531,4802,4914,5006,5211,5382,5548,5703,5747,6151,6328,6386,6392,6515,6583,6591,6700,6978,7173,7213,7396,7502,7649,7768,7813,8227,8238,8368,8412,8441,8569,8635,8839,9117,9138,9230,9290,9350,9474,9492,9601,9677,9789,9790,9952],[6,27,166,178,187,200,286,432,502,668,671,825,867,917,1011,1015,1249,1308,1325,1454,1478,1522,1619,1939,2232,2316,2399,2490,2650,2697,2911,2929,3097,3115,3463,3507,3528,3619,3801,3813,3947,3959,3986,4037,4051,4103,4267,4435,4454,4563,4574,4582,4671,4678,4694,4726,4823,5024,5360,5398,5966,5991,6090,6203,6229,6445,6473,6483,6589,6633,6683,6938,6978,7075,7567,7631,7748,7809,7828,7996,8014,8026,8063,8155,8228,8247,8269,8306,8395,8456,8553,8919,9005,9147,9446,9499,9763,9773,9793,9941],[36,148,240,369,415,491,503,728,905,919,925,963,981,1089,1381,1386,1390,1670,1740,1873,2013,2077,2249,2274,2285,2462,2610,2645,2652,2730,2757,2800,3303,3323,3465,3501,3542,3697,3727,3799,4010,4119,4140,4223,4269,4402,4496,4652,4706,4782,4909,5151,5425,5428,5541,5567,5617,5627,5684,5877,6100,6155,6308,6314,6329,6356,6384,6534,6571,6662,6850,6890,6966,7079,7117,7415,7456,7534,7581,7678,7719,7818,7857,7860,7904,7932,7999,8078,8263,8373,8505,8535,8790,9077,9178,9210,9229,9288,9549,9940],[181,279,375,434,650,793,870,892,920,1009,1023,1105,1157,1228,1353,1432,1544,1607,1643,1811,1834,2047,2057,2179,2303,2802,2854,2867,2883,2901,2977,3041,3093,3291,3367,3598,3620,3627,3643,3648,3663,3672,3683,3702,4035,4102,4216,4228,4315,4421,4579,4716,4759,4773,4868,5066,5094,5202,5531,5804,5824,6002,6013,6041,6057,6084,6233,6396,6438,6493,6678,6824,6908,6934,6978,7262,7417,7434,7543,7688,7979,8021,8066,8082,8188,8394,8437,8447,8505,8531,8565,8789,8801,9022,9226,9394,9450,9494,9496,9656],[98,137,215,291,381,431,487,641,712,771,935,1540,1566,1776,1860,2000,2079,2230,2306,2529,2584,2739,2753,2769,2771,3049,3079,3080,3115,3130,3212,3766,3991,3993,4061,4081,4088,4118,4133,4158,4319,4567,4602,4635,4715,4742,4934,4970,5035,5042,5095,5165,5306,5482,5542,5606,5640,5643,5909,5986,6006,6070,6105,6123,6185,6396,6495,6511,6666,6832,6850,7141,7196,7254,7316,7328,7396,7432,7632,7881,8222,8256,8293,8437,8470,8501,8716,8736,8765,8910,8944,8973,9034,9517,9526,9604,9737,9828,9885,9998],[37,200,228,295,309,404,431,452,468,650,677,785,789,794,801,803,870,904,955,1062,1254,1471,1560,1575,1635,1829,2280,2292,2356,2384,2408,2525,2680,3137,3267,3347,3365,3371,3660,3744,3788,3849,4011,4022,4243,4279,4318,4388,4436,4927,4948,4998,4999,5065,5075,5223,5415,5463,5630,5713,5719,5775,5927,6072,6078,6266,6312,6365,6391,6392,6516,6610,6680,6699,7105,7119,7136,7266,7317,7331,7358,7412,7461,7550,7567,7868,8198,8421,8705,8732,8758,8851,9087,9105,9167,9201,9209,9472,9615,9888],[80,136,169,190,237,471,651,799,864,1219,1730,1813,1960,1961,1963,2127,2177,2331,2662,2676,2716,2855,3053,3067,3274,3296,3350,3457,3531,3621,3771,3789,3873,3959,4133,4246,4440,4444,4519,4534,4623,4739,4780,4877,4884,5010,5187,5196,5425,5479,5586,5677,5974,6003,6189,6457,6551,6566,6587,6632,6649,6782,6965,7051,7180,7215,7387,7449,7466,7551,7657,7821,7827,7851,7892,8046,8077,8185,8265,8594,8605,8639,8666,8701,8750,8860,8919,9020,9081,9130,9172,9241,9258,9373,9376,9481,9868,9869,9919,9948],[153,216,226,289,322,425,513,548,556,563,567,592,596,606,678,973,1057,1187,1263,1278,1331,1337,1400,1551,1568,1642,1959,2037,2090,2120,2249,2359,2478,2508,2511,2585,2646,2686,2735,2784,2995,3165,3186,3390,3433,3506,3666,3669,4063,4115,4130,4190,4386,4552,4614,4637,4640,4728,4815,5022,5206,5594,5637,6011,6071,6090,6118,6318,6370,6580,6585,7191,7340,7529,7621,7716,7740,7781,8020,8048,8093,8375,8443,8496,8502,8627,8761,8930,8987,8991,9087,9088,9219,9252,9261,9396,9553,9792,9868,9966],[55,95,196,215,228,249,387,444,491,534,813,823,864,953,1153,1362,1388,1414,1417,1443,1519,1570,1572,1692,2001,2059,2111,2317,2374,2867,3035,3130,3141,3367,3436,3582,3612,3681,3736,4045,4128,4265,4362,4414,4547,4622,4702,4835,4904,5071,5134,5153,5222,5299,5315,5727,5795,5804,5825,5866,5960,6012,6029,6129,6180,6326,6354,6450,6471,6556,6834,6854,6855,7081,7082,7597,7732,7789,7833,7984,8094,8133,8205,8240,8257,8363,8428,8459,8651,8900,8913,8930,9037,9128,9350,9373,9606,9776,9788,9879],[220,263,360,435,613,736,754,915,1004,1134,1280,1318,1536,1585,1648,1876,2137,2189,2556,2589,2728,2831,2880,2915,3043,3235,3366,3405,3457,3496,3509,3595,3630,3670,3723,3783,3849,3877,3887,4031,4091,4159,4427,4474,4591,4769,4889,4917,5056,5067,5129,5233,5387,5407,5488,5504,5625,5668,5695,5699,5847,5868,5885,5922,6128,6320,6431,6465,6518,6755,6782,6873,6991,7001,7094,7099,7293,7365,7687,7784,8080,8169,8180,8193,8367,8417,8562,8694,8715,8722,8795,8930,9351,9356,9374,9503,9669,9882,9925,9941],[31,79,172,217,328,426,503,627,770,950,1286,1289,1309,1327,1477,1535,1592,1628,1755,1758,1760,1869,1886,1895,2054,2154,2231,2264,2383,2389,2547,2601,2937,3010,3074,3192,3304,3536,3580,3668,3697,3864,3883,3884,4040,4241,4271,4288,4408,4415,4519,4799,4847,4851,4908,5112,5243,5335,5651,5658,5675,5719,5803,5831,5888,6156,6174,6273,6297,6320,6486,6521,6659,6668,6770,6780,6884,7049,7367,7372,7390,7711,7732,7774,7811,8065,8066,8229,8243,8323,8326,8661,8772,8881,9028,9352,9472,9606,9771,9877],[182,406,431,535,707,724,746,880,952,993,1097,1109,1133,1208,1238,1423,1429,1448,1521,1558,1696,1864,2270,2426,2506,2801,2808,2860,2955,3035,3217,3220,3226,3293,3369,3411,3463,3521,3729,3776,3817,3866,3873,3878,3989,4144,4243,4281,4418,4578,4702,4800,4991,5116,5364,5381,5485,5593,5629,5631,5664,5722,5934,6128,6277,6297,6562,6571,6698,6887,6961,7081,7152,7247,7273,7346,7672,7925,7927,7972,8082,8124,8345,8470,8504,8536,8538,8821,8957,9012,9180,9208,9254,9288,9362,9552,9625,9823,9858,9891],[51,168,256,295,312,620,686,760,854,979,987,1248,1349,1541,1638,1691,1968,2112,2115,2267,2268,2337,2343,2361,2431,2463,2551,2865,2886,3024,3065,3143,3322,3784,3976,4146,4400,4519,4530,4566,4686,4828,4883,5043,5093,5167,5261,5400,5469,5554,5585,5669,5690,5771,5935,6111,6197,6373,6395,6440,6510,6548,6696,6770,6793,6815,6881,6890,6943,6986,7026,7160,7318,7403,7457,7490,7899,7949,8088,8234,8252,8448,8589,8646,8695,8734,8961,9042,9164,9264,9276,9356,9497,9574,9769,9789,9831,9871,9926,9980],[170,300,322,337,341,600,717,1017,1043,1137,1143,1298,1382,1392,1550,1905,1957,2105,2213,2293,2323,2346,2354,2440,2917,2918,3090,3144,3277,3409,3683,3706,3792,3903,3946,4034,4229,4309,4675,5040,5047,5055,5210,5239,5266,5310,5323,5417,5591,5753,5769,5915,5917,5922,5935,5986,6051,6093,6221,6227,6267,6301,6344,6735,6831,6878,6959,7186,7386,7530,7549,7560,7587,7707,7773,7868,7919,7983,8010,8130,8132,8414,8548,8597,8620,8643,8843,9097,9108,9110,9208,9276,9433,9445,9517,9587,9754,9828,9867,9930],[195,385,570,579,639,645,726,761,786,854,912,919,933,1138,1218,1296,1398,1586,1722,1854,1920,1997,2049,2077,2083,2281,2338,2367,2569,2601,2674,3136,3185,3235,3697,3724,3777,3788,3819,3857,3983,4008,4040,4141,4168,4169,4218,4219,4227,4250,4282,4619,4633,4641,4646,4665,4745,4897,5040,5122,5175,5196,5314,5773,5891,5953,6151,6378,6474,6706,6800,6968,7010,7292,7359,7563,7572,7726,7855,8093,8167,8281,8348,8435,8483,8600,8645,8649,8820,8906,8974,9118,9164,9199,9432,9446,9515,9711,9756,9882],[69,141,144,184,327,392,526,529,671,752,1155,1168,1264,1508,1564,1611,1626,1769,1795,1931,2164,2225,2614,2675,2728,2845,2920,3103,3104,3111,3223,3346,3423,3472,3571,3594,3625,3839,3938,3939,4337,4394,4406,4524,4542,4617,4678,4731,4893,4999,5014,5036,5059,5086,5114,5140,5391,5594,5659,5714,5912,5954,6002,6127,6156,6342,6462,6525,6571,6619,6653,6776,6781,6844,7205,7257,7506,7544,7606,7666,7805,7862,7948,7956,8108,8140,8163,8176,8480,8543,8870,9096,9308,9460,9684,9837,9872,9933,9968,9991],[52,184,249,361,699,730,812,837,911,944,1158,1388,1443,1483,1505,1565,1644,1649,1725,1790,1828,1992,2006,2150,2701,2897,2942,2966,3034,3059,3080,3091,3420,3589,3601,3677,3847,3860,4056,4314,4355,4362,4369,4434,4520,4726,4738,4838,4858,4926,5091,5214,5232,5315,5318,5339,5372,5393,5404,5531,5592,5643,5827,5850,6162,6301,6496,6659,6727,6831,6841,6847,7222,7223,7248,7289,7296,7361,7386,7388,7433,7738,7876,8079,8081,8173,8219,8363,8544,8658,8751,8864,8865,8890,8984,9444,9613,9724,9853,9950],[176,295,317,352,364,445,454,576,594,698,769,864,1025,1068,1095,1245,1587,1627,1790,1830,1991,2014,2402,2438,2457,2648,2658,2738,2758,2770,3045,3129,3166,3397,3409,3411,3433,3645,3660,3675,3808,3968,4006,4103,4168,4204,4410,4429,4510,4617,4718,4882,5031,5087,5143,5153,5178,5233,5324,5383,5518,5666,5684,5987,6081,6241,6539,6548,6786,7153,7180,7413,7420,7435,7455,7719,7848,7911,8076,8220,8332,8404,8448,8579,8612,8628,8642,8763,8856,8859,8880,8885,8948,9004,9086,9256,9317,9392,9772,9835],[28,200,232,305,369,694,844,938,1221,1232,1284,1471,1578,1615,1619,1665,1841,1937,2040,2164,2207,2223,2273,2289,2461,2467,2610,2735,2843,2915,2921,2977,3066,3071,3375,3505,3637,3641,3714,3823,3852,3952,3966,4100,4120,4150,4188,4294,4388,4456,4633,4767,4802,4810,5002,5009,5285,5355,5526,5584,5716,5800,5813,5904,6162,6347,6586,6687,6759,6779,6862,6863,7094,7265,7448,7718,7726,8574,8580,8650,8934,8936,8940,8962,9074,9101,9143,9150,9243,9244,9277,9333,9437,9487,9587,9606,9788,9813,9861,9880],[341,469,582,680,706,861,1019,1071,1148,1346,1490,1534,1832,1973,1996,2068,2129,2188,2205,2318,2342,2353,2453,2552,2621,2708,2871,3248,3259,3441,3444,3603,3640,3678,3690,3767,3903,3919,3956,4189,4229,4247,4272,4451,4714,4783,4818,4867,4887,4903,4981,5083,5113,5206,5261,5293,5322,5412,5546,5561,5610,5628,5636,5737,5827,5858,6005,6297,6728,6795,6975,7061,7163,7167,7179,7249,7386,7454,7612,7626,7637,7655,7688,7874,8163,8265,8351,8364,8550,8711,8776,8812,9434,9503,9573,9595,9704,9838,9865,9946],[269,272,309,329,415,533,587,665,982,1008,1030,1308,1333,1349,1464,1537,1751,1766,1982,2271,2498,2612,2666,2784,3221,3429,3470,3763,3772,3807,3824,3933,4162,4192,4215,4360,4400,4417,4593,4885,4974,5021,5098,5158,5367,5411,5464,5602,5708,5810,5883,5926,5975,6020,6070,6150,6151,6211,6360,6364,6559,6690,6714,6762,6807,6925,7225,7228,7319,7396,7463,7466,7489,7536,7600,7604,8028,8115,8231,8444,8467,8507,8561,8823,8945,9054,9064,9096,9202,9276,9335,9428,9432,9556,9578,9670,9776,9870,9903,9997],[35,163,189,317,327,403,447,544,659,720,784,1086,1227,1318,1369,1413,1486,1564,1863,1948,2031,2255,2265,2302,2504,2542,2673,2704,2839,2854,2914,2932,3129,3196,3277,3380,3437,3452,3538,3566,3701,3771,3861,4034,4128,4140,4150,4521,4663,4739,4984,5002,5094,5097,5204,5231,5304,5486,5508,5545,5685,5823,5874,5923,5988,6000,6019,6098,6199,6296,6530,6568,6603,6861,6943,6984,7019,7129,7167,7322,7428,7715,7747,8137,8187,8329,8460,8640,8773,9016,9017,9216,9345,9469,9494,9545,9558,9762,9946,9998],[8,95,579,639,767,945,1010,1032,1142,1166,1264,1355,1415,1664,1869,1917,1938,2152,2172,2173,2187,2197,2328,2368,2389,2504,2510,2516,2575,2748,2974,3074,3090,3351,3410,3699,3812,3889,3905,4044,4174,4313,4345,4426,4471,4629,4634,4969,5085,5113,5252,5288,5329,5353,5633,5705,5755,5806,5909,5960,5999,6071,6128,6187,6311,6374,6393,6424,6525,6695,6719,6933,6984,7438,7461,7504,7506,7562,7652,7756,7760,7826,8001,8038,8050,8131,8139,8154,8255,8285,8427,8981,9010,9036,9071,9091,9158,9168,9337,9436],[88,130,358,381,657,659,870,992,1006,1017,1021,1062,1172,1234,1238,1335,1389,1480,1577,1834,1940,2129,2182,2377,2378,2450,2456,2493,2518,2622,2658,2677,2747,2761,2788,3105,3306,3593,3791,3813,4023,4034,4039,4061,4146,4147,4169,4258,4264,4277,4336,4406,4428,4455,4863,4889,5414,5528,5557,5587,5764,5845,5885,6206,6251,6368,6388,6547,6618,6769,6782,6957,7321,7334,7380,7455,7544,7635,7648,7731,7794,7808,8046,8115,8260,8945,9113,9343,9364,9482,9550,9580,9655,9657,9665,9667,9755,9818,9950,9976],[51,181,200,278,321,406,471,622,924,939,977,1526,1797,1813,1814,1886,2042,2152,2267,2295,2308,2379,2610,3124,3163,3172,3199,3268,3271,3273,3648,3718,4014,4042,4077,4191,4198,4206,4321,4462,4827,4961,4973,5279,5285,5627,5661,5719,5795,5860,6036,6140,6210,6328,6353,6407,6416,6429,6475,6493,6506,6659,6863,6893,6924,6974,7090,7120,7219,7235,7257,7291,7293,7427,7625,7664,7668,7688,7758,7796,7997,8002,8124,8230,8362,8409,8474,8695,8897,9009,9116,9193,9273,9338,9475,9508,9557,9940,9985,9987],[84,222,240,310,409,426,495,587,767,838,872,1110,1240,1310,1878,1955,2164,2381,2517,2521,2523,2525,2576,2679,2699,3161,3189,3264,3498,3841,3955,3979,3982,4024,4212,4215,4252,4281,4463,4495,4548,4574,4676,4740,4768,4834,4858,4864,5029,5039,5112,5175,5330,5534,5567,5727,5808,5903,6018,6158,6189,6209,6229,6476,6541,6595,6752,6840,6958,7238,7256,7684,7821,7872,7903,7958,7995,8084,8087,8147,8187,8255,8277,8280,8390,8563,8609,8674,8681,8768,9073,9126,9162,9174,9195,9242,9351,9402,9434,9930],[94,162,327,339,348,356,409,696,885,1188,1225,1586,1705,1821,1863,1989,2016,2025,2080,2102,2159,2187,2218,2265,2668,2780,2856,3019,3083,3174,3181,3289,3346,3452,3460,3579,3627,3632,3793,3886,3950,4071,4134,4198,4469,4710,4842,4934,5132,5207,5266,5379,5396,5457,5623,5832,5936,5955,6135,6334,6478,6529,6662,6717,6769,6784,6973,6988,7016,7078,7206,7242,7270,7292,7505,7676,7984,8177,8409,8522,8536,8556,8728,8738,8740,8824,8853,8871,9101,9113,9175,9208,9319,9418,9534,9678,9703,9828,9988,9993],[43,74,76,158,262,426,552,604,662,693,703,832,1044,1240,1339,1602,1639,1737,1999,2010,2192,2204,2219,2269,2396,2422,2530,2591,2669,2695,2740,2769,3004,3103,3122,3473,3491,3759,3803,3832,3878,4397,4456,4633,4657,4757,5011,5017,5022,5061,5118,5169,5180,5188,5214,5289,5418,5620,5728,5780,6272,6400,6448,6548,6556,6567,6653,6871,7000,7148,7317,7358,7409,7412,7459,7495,7575,7776,7808,7904,8175,8339,8432,8565,8570,8649,8651,8696,8700,8739,8852,8877,9051,9237,9288,9328,9408,9522,9605,9723],[110,121,174,477,630,644,796,811,864,944,1319,1485,1749,1792,1954,1988,2050,2242,2255,2295,2311,2317,2396,2602,2646,2917,3065,3104,3302,3453,3469,3508,3657,3702,3716,3804,3918,4083,4089,4241,4328,4347,4413,4655,4723,4726,4915,4953,5068,5168,5329,5389,5401,5410,5549,5585,5592,5614,5615,5810,5817,5897,5985,6161,6586,6597,6797,6853,6873,6948,7398,7467,7530,7580,7596,7613,7632,7641,7715,7771,7941,7952,7998,8000,8159,8180,8248,8345,8497,8606,9143,9228,9310,9348,9435,9678,9683,9885,9938,9990],[23,114,231,416,476,551,607,719,758,890,1025,1043,1135,1167,1228,1359,1410,1464,1528,1705,1737,1750,1799,1843,1880,1973,2009,2140,2196,2560,2734,2821,2924,2971,3047,3368,3468,3526,3529,3735,3951,4002,4080,4228,4299,4620,5026,5036,5247,5310,5323,5629,5810,5873,5895,6143,6175,6286,6338,6388,6432,6623,6773,6961,7113,7298,7306,7318,7339,7493,7515,7646,7676,7695,7831,7909,7969,8006,8251,8345,8356,8512,8553,8662,8702,8719,8755,8784,8943,9005,9095,9106,9210,9329,9358,9366,9391,9565,9596,9665],[2,62,63,140,224,277,300,441,470,576,643,1066,1225,1281,1358,1367,1698,1718,1782,1807,2017,2142,2191,2295,2370,2424,2601,2879,2882,2965,3009,3028,3038,3231,3284,3392,3458,3463,3482,3608,3612,3727,3745,3789,3889,3995,4026,4090,4289,4294,4330,4486,4497,4572,4813,4853,4884,4921,5394,5406,5544,5639,5742,5789,6056,6063,6388,6433,6499,6537,6677,6861,7000,7137,7155,7196,7207,7334,7713,7892,8081,8124,8294,8357,8448,8725,8906,9002,9086,9091,9095,9119,9447,9453,9546,9607,9694,9742,9884,9927],[51,79,125,179,236,245,258,268,330,337,543,647,952,959,1062,1215,1313,1320,1700,1802,1856,1913,1922,2049,2054,2113,2134,2170,2184,2422,2451,2484,2973,2979,3079,3106,3266,3717,3812,3854,3912,3993,4106,4122,4146,4166,4316,4318,4380,4643,4801,4808,4859,4953,5288,5529,5575,5586,5632,5745,5804,5824,5895,5950,5954,6288,6291,6310,6389,6571,6611,6664,6760,6804,6864,6955,7083,7172,7467,7495,7558,7680,7742,7939,7989,8204,8300,8460,8523,8674,8687,8740,8797,8968,9120,9187,9226,9252,9627,9653],[9,95,201,293,482,583,864,967,1037,1093,1345,1559,1640,1734,1781,1846,1847,2109,2221,2295,2338,2497,2711,2734,2740,2909,3012,3323,3332,3416,3443,3466,3535,3552,3601,3648,3860,4050,4267,4292,4382,4408,4445,4490,4524,4637,4640,4758,4798,4929,4933,4938,5056,5120,5125,5151,5183,5486,5549,5612,5698,5788,5823,5873,6255,6464,6565,6577,6840,6960,7195,7255,7424,7446,7566,7622,7677,7700,8073,8203,8241,8251,8315,8328,8443,8473,8519,8608,8687,8738,8763,8950,8997,9103,9172,9216,9703,9723,9746,9925],[239,394,427,746,870,970,981,1163,1247,1251,1255,1319,1408,1447,1583,1885,1944,1972,2001,2042,2294,2412,2588,2630,2738,2759,2809,3111,3224,3383,3505,3524,3556,3658,3660,3835,3853,3866,3943,3956,4019,4151,4204,4379,4428,4528,4566,4643,4727,4769,4787,4822,4834,4908,4913,5492,5573,5574,5677,5694,5729,5754,5778,5926,6030,6077,6245,6325,6364,6455,6459,6479,6522,6674,6693,6865,6969,7003,7179,7277,7330,7520,7821,7988,8582,8758,8831,8846,8849,9223,9229,9300,9380,9465,9610,9670,9786,9844,9895,9962],[267,363,513,643,770,829,882,937,991,1066,1129,1334,1349,1413,1665,1785,2167,2311,2344,2374,2585,2628,2718,2730,2752,2773,3456,3471,3480,3552,3554,3621,3781,4002,4053,4165,4317,4331,4402,4452,4496,4578,4640,4719,4721,4798,4868,4905,4908,4968,5117,5188,5281,5292,5326,5356,5385,5516,5556,5558,5564,5617,5820,5829,6020,6070,6101,6225,6437,6483,6811,6832,6880,6896,7477,7597,7709,7721,7734,7777,7910,8126,8243,8370,8578,8627,8683,8796,8816,8921,9074,9169,9207,9248,9363,9679,9714,9758,9763,9907],[124,201,323,406,420,492,701,790,921,1031,1038,1299,1346,1426,1795,1855,1894,2078,2448,2584,2644,2692,2831,2855,2890,2940,3046,3082,3215,3239,3459,3495,3509,3522,3549,3571,3928,3937,4075,4095,4131,4341,4388,4488,4600,4950,5038,5049,5285,5384,5432,5549,5584,5600,5605,5746,5818,5854,6020,6366,6372,6516,6529,6722,6853,6972,7025,7125,7132,7182,7194,7627,7654,7656,7672,7679,7713,7888,7902,7969,7997,8021,8131,8250,8449,8480,8558,8585,8621,8699,8724,8778,8999,9015,9299,9322,9442,9621,9749,9963],[129,379,404,436,448,505,568,629,947,1097,1128,1232,1270,1278,1379,1455,1696,1940,1970,2255,2359,2374,2400,2477,2664,2740,2790,2982,3070,3249,3379,3483,3604,3612,3827,3854,3939,4159,4236,4396,4574,4584,4746,4925,4962,5162,5203,5302,5306,5463,5521,5545,5579,5633,5650,5715,5848,5937,6234,6241,6253,6256,6367,6491,6589,6677,6800,6828,6910,6924,7182,7199,7536,7576,7639,7666,7692,7770,7856,7959,8094,8347,8350,8394,8461,8595,8632,8660,8695,8744,8755,8799,8991,9013,9148,9285,9572,9601,9637,9892],[46,101,183,201,256,468,671,708,858,863,897,971,996,1000,1024,1091,1282,1317,1600,1816,1879,1881,1959,1983,2116,2223,2309,2392,2396,2550,2849,2853,2941,2999,3012,3028,3170,3206,3492,3561,3562,3743,4159,4274,4280,4285,4311,4386,4393,4435,4446,4572,4579,4618,4746,4753,4937,5076,5112,5152,5261,5302,5348,5570,5749,5807,6148,6385,6431,6555,6899,7013,7051,7093,7170,7249,7401,7907,7921,8187,8399,8452,8528,8823,8879,8896,8917,9059,9272,9369,9379,9433,9482,9571,9572,9599,9645,9706,9829,9883],[3,356,435,538,1177,1294,1480,1702,2197,2230,2328,2359,2514,2516,2614,2634,2652,2667,2750,2854,2870,2971,3179,3189,3215,3394,3473,3560,3613,3623,3670,3672,3978,4073,4108,4218,4269,4424,4459,4511,4687,4976,5008,5100,5130,5162,5330,5346,5402,5438,5779,5794,6120,6154,6285,6325,6356,6362,6579,6639,6681,6713,6768,6801,6830,6855,6878,6892,6933,7001,7269,7270,7384,7483,7538,7737,8106,8146,8247,8284,8316,8331,8365,8612,8669,8771,8856,8869,9053,9078,9089,9168,9260,9282,9380,9458,9491,9543,9620,9889],[156,315,345,406,592,776,820,1049,1138,1162,1375,1481,1487,1507,1534,1541,1574,1703,1974,2288,2336,2394,2406,2410,2414,2579,2640,2691,2699,2738,2810,2833,2864,3347,3375,3629,3708,3838,3980,4093,4156,4185,4208,4324,4376,4420,4626,4679,5129,5206,5249,5287,5366,5404,5461,5467,5683,5848,6183,6212,6343,6371,6453,6500,6576,6686,6701,6767,6945,7019,7358,7365,7558,7591,7702,7704,7714,7725,7762,7934,7968,8164,8277,8355,8569,8597,8600,8672,8730,8812,8896,9034,9227,9334,9469,9497,9599,9720,9751,9939],[368,589,791,815,969,986,995,1111,1123,1161,1180,1222,1282,1350,1401,1491,1633,1733,1813,1955,2086,2174,2499,2587,2832,2932,3110,3196,3218,3403,3407,3454,3530,3556,3585,3828,3874,4002,4016,4131,4353,4376,4687,4720,4830,4855,4907,4932,4951,5060,5102,5199,5235,5348,5409,5494,5563,5668,5750,5759,5796,5898,5953,6077,6213,6227,6527,6541,6567,6627,6663,6698,7049,7066,7190,7215,7256,7357,7420,7522,7592,7989,8035,8102,8138,8216,8223,8271,8776,8852,8956,9006,9170,9194,9313,9350,9517,9678,9759,9904],[160,280,333,363,498,501,849,925,935,1093,1239,1360,1468,1549,1628,1697,1865,1885,1939,1963,2022,2036,2220,2256,2300,2310,2345,2382,2397,2471,2495,2873,2901,2916,2929,2966,3061,3475,3509,3532,3592,3789,3849,4002,4023,4043,4129,4165,4194,4205,4235,4237,4245,4253,4328,4448,4566,4594,4646,4797,4888,5017,5313,5570,5619,5773,5794,5795,5823,5841,5852,5865,5932,5962,6208,6481,6490,6615,7029,7386,7421,7470,7593,7940,7980,8228,8242,8439,8491,8659,8705,8875,8945,9050,9124,9268,9406,9765,9867,9885],[27,62,177,263,307,448,652,661,707,710,718,873,1313,1479,1481,1603,1621,1710,1845,2130,2306,2330,2451,2509,2564,2610,2646,2693,2707,2911,2934,2991,3022,3034,3068,3076,3132,3188,3411,3412,3426,3443,3459,3635,3742,3879,3910,3931,3993,4033,4036,4311,4337,4397,4427,4479,4559,4875,4919,4943,5099,5304,5381,5538,5647,5796,5864,5934,6052,6074,6156,6245,6366,6388,6592,6767,6831,6838,6841,6924,7072,7293,7499,7817,7874,7909,7987,8134,8160,8235,8285,8364,8880,9001,9133,9142,9272,9524,9728,9886],[70,131,186,328,343,397,503,679,691,782,960,1075,1102,1160,1305,1345,1748,1866,1874,2007,2066,2140,2145,2247,2423,2426,2567,2623,2819,2879,2917,2933,3070,3490,3523,3704,3736,3813,3816,3977,4075,4151,4229,4335,4447,4489,4495,4499,4605,4642,4926,4997,5076,5188,5369,5472,5568,5688,6055,6117,6205,6325,6406,6584,6624,6722,6729,6818,7187,7381,7388,7410,7455,7490,7539,7553,7653,7817,7885,7972,7993,8137,8189,8281,8286,8294,8377,8475,8602,8649,8767,8794,9163,9244,9496,9521,9601,9857,9988,9998],[160,232,247,288,364,417,423,720,995,1032,1260,1487,1503,1646,1739,1786,1849,1859,1891,1932,1976,1991,1996,2233,2419,2462,2465,2482,2754,2837,2924,2998,2999,3242,3327,3403,3430,3517,3533,3598,3752,3868,4047,4058,4088,4372,4439,4651,4662,4734,4838,4843,4911,4968,5001,5047,5137,5407,5472,5530,5753,5981,6001,6081,6275,6496,6579,6846,7000,7226,7250,7296,7347,7627,7642,7645,7737,7761,7858,8037,8123,8161,8215,8323,8355,8405,8423,8459,8582,8716,8743,8815,8910,8968,9143,9310,9397,9789,9890,9950],[84,186,216,281,375,572,921,1345,1447,1459,1633,1836,1903,1949,2212,2438,2527,2598,2678,2779,2994,3089,3129,3262,3303,3332,3360,3489,3695,3782,3931,3988,4217,4222,4252,4272,4487,4695,4742,4788,4954,4993,5051,5062,5159,5356,5738,5905,5984,6158,6304,6318,6325,6329,6386,6392,6399,6623,6633,6788,6921,7016,7035,7102,7247,7302,7324,7394,7422,7436,7553,7609,7616,7700,7791,7961,8021,8092,8148,8153,8188,8209,8404,8411,8678,8714,8800,8931,8932,9098,9136,9253,9274,9329,9421,9422,9439,9681,9760,9941],[45,71,146,239,399,487,544,552,718,765,980,1078,1135,1247,1313,1350,1375,1482,1490,1502,1513,1577,1655,1744,1798,1808,1965,1983,2077,2086,2241,2520,2537,2661,2771,2800,2864,2903,2976,3505,3531,3699,3955,3985,4196,4222,4335,4583,4686,4833,4924,4956,5030,5043,5083,5095,5096,5116,5341,5383,5406,5495,5653,5672,5679,5732,5985,6026,6084,6392,6627,6630,6800,7263,7281,7296,7628,7667,8166,8187,8232,8240,8276,8491,8514,8541,8643,8716,8819,8897,8974,9063,9125,9176,9215,9222,9576,9609,9754,9829],[51,522,783,880,1063,1209,1378,1875,1880,1942,1970,2098,2218,2242,2375,2498,2511,2517,2615,2735,2816,2819,3004,3089,3113,3121,3135,3257,3356,3630,3882,3900,3919,3940,4128,4144,4174,4234,4266,4333,4468,4650,4714,4753,4882,5020,5075,5165,5234,5473,5499,5580,5648,5688,5696,5710,5817,5826,5903,6000,6097,6243,6440,6569,6618,6671,6757,6830,6831,6966,7150,7413,7462,7616,7641,7673,7813,7814,8066,8272,8332,8392,8494,8520,8556,8564,8977,9031,9043,9284,9372,9382,9463,9515,9533,9537,9622,9736,9818,9912],[2,54,56,135,182,229,549,625,953,955,1203,1556,1595,1631,1740,1804,2077,2080,2105,2181,2522,2527,2651,2652,2667,2755,2793,2986,3018,3047,3094,3211,3253,3332,3492,3750,3751,4009,4298,4376,4408,4432,4434,4465,4528,4579,4794,4826,4940,4951,4965,5096,5202,5206,5420,5459,5684,5959,5996,6074,6363,6411,6474,6581,6753,6760,6791,6849,6903,7068,7418,7425,7476,7510,7570,7620,7634,7727,7890,7898,7961,7992,8164,8211,8278,8340,8599,8615,8654,8683,9121,9140,9181,9224,9328,9370,9561,9582,9636,9936],[55,270,277,453,519,648,958,984,1077,1168,1435,1532,1535,1929,1949,2051,2063,2222,2335,2346,2351,2376,2588,2593,2684,2781,2864,2972,3041,3194,3537,3542,3588,3722,3897,3902,3969,3980,4171,4317,4385,4395,4523,4898,4998,5253,5413,5637,5724,5756,5809,5810,5813,5916,5939,6064,6170,6218,6243,6254,6853,6980,7068,7207,7247,7301,7363,7389,7418,7524,7544,7990,8035,8041,8194,8278,8289,8394,8431,8454,8606,8681,8764,8859,8972,8975,9081,9156,9263,9274,9382,9499,9524,9542,9607,9614,9704,9894,9914,9981],[37,42,298,299,377,740,802,923,950,1111,1112,1141,1217,1238,1306,1386,1419,1691,1803,1870,1881,2059,2079,2194,2354,2401,2798,2978,2997,3026,3055,3171,3436,3543,3558,3661,3665,3669,3984,4016,4046,4193,4411,4519,4540,4614,4839,4880,5033,5106,5136,5250,5379,5421,5710,5715,5716,5752,5811,5857,6016,6165,6217,6275,6277,6499,6717,6754,6815,6854,6943,6990,7033,7139,7147,7752,7789,7833,7889,7934,7971,7985,8092,8340,8502,8616,8659,8680,8780,9194,9290,9392,9462,9503,9538,9653,9684,9738,9795,9903]]

    result = soln.smallestCommonElement(mat)
    print(result)
